<?php
namespace Teknisa\FAI\Modules\Relatorio\Controllers;


use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;

class Fai13000ResumoDeFaturamento extends \Zeedhi\Framework\Controller\Report {

	protected $birtStrategy;
	protected $reportService;
	protected $environment;

    public function __construct(ReportService $reportService, $birtStrategy, $environment) {
        $this->birtStrategy  = $birtStrategy;
        $this->reportService  = $reportService;
        $this->environment = $environment;
    }

	protected $reportMapping = array (
		'FAI13000' =>
		array (
			'strategy' => 'BIRT',
			'parameterMapping' =>
			array (
				'FILIAL'  	=> 'P_CDFILIAL',
				'TCDFILIAL'  => 'P_TODOS',
				'DTINICIAL' => 'P_DTINICIAL',
				'DTFINAL'   => 'P_DTFINAL',
				'NRORG' => 'P_NRORG'
			)
		),
		'FAI13001' =>
		array (
			'strategy' => 'BIRT',
			'parameterMapping' =>
			array (
				'FILIAL'  	=> 'P_CDFILIAL',
				'TCDFILIAL'  => 'P_TODOS',
				'DTINICIAL' => 'P_DTINICIAL',
				'DTFINAL'   => 'P_DTFINAL',
				'NRORG' => 'P_NRORG'
			)
		)
	);
	
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $row['NRORG'] = $this->environment->getNrorgTrab();
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    }
}